package java2D2compositing;

import javax.swing.*;

import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;



public class PainterView extends JFrame {
    JRadioButton circleRadioButton = new JRadioButton("Kreis",false);
    
    JRadioButton roundRectRadioButton = new JRadioButton("RundBox",false);
    
    JRadioButton arcRadioButton = new JRadioButton("Bogen",false);
    
    JRadioButton rectRadioButton = new JRadioButton("Rechteck",false);
    
    JRadioButton gPathRadioButton = new JRadioButton("Pfad", false);
    
    JRadioButton fillEvenOddRadioButton = new JRadioButton("Even_Odd", false);
    
    JRadioButton fillNonZeroRadioButton = new JRadioButton("Non_Zero", false);
    
    JButton clearButton = new JButton("clear");
    JButton rotButton = new JButton("rot_r");
    
    JRadioButton redRadioButton = new JRadioButton("Rot",false);
    JRadioButton blueRadioButton = new JRadioButton("Blau",false);
    
    JRadioButton gradientRadioButton = new JRadioButton("Gradient",false);
    
    
    JPanel buttonGroupPanel = new JPanel();
    JRadioButton textRadioButton = new JRadioButton("Textur",false);
    
    
    ButtonGroup shapeButtonGroup;
    ButtonGroup colorChooserButtonGroup;
    ButtonGroup windingRuleButtonGroup;
    RenderCanvas canvas;
    
    JCheckBox ditheringCheckbox = new JCheckBox("Dithering");
    JCheckBox antiAliasingCheckBox = new JCheckBox("AntiAlaising");
    JTextField rotAngleField = new JTextField("0",6);
    
    JPanel renderingPanel = new JPanel();
    JPanel lowerPanel = new JPanel();
    JPanel buttonPanel = new JPanel();
    JPanel upperPanel = new JPanel();
    JPanel windingRulePanel = new JPanel();
    JPanel colorPanel = new JPanel();
    JPanel allPanel = new JPanel();
    JCheckBox clipping = new JCheckBox("Clipping",false);
    
            
    CanvasModel cm = new CanvasModel();
    JMenu compRulesMenu;
    
    public PainterView(String titel) {
        
        super(titel);
        this.getContentPane().setLayout(new BorderLayout());
        
        
        
        //Shapes
        circleRadioButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                State.setShapeOption(DrawUtils.getInstance().getCircle());
            }
        });
        rectRadioButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                State.setShapeOption(DrawUtils.getInstance().getRect());
            }
        });
        roundRectRadioButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                State.setShapeOption(DrawUtils.getInstance().getRoundRect());
            }
        });
        arcRadioButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                State.setShapeOption(DrawUtils.getInstance().getArc());
            }
        });
        gPathRadioButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                State.setShapeOption(DrawUtils.getInstance().getGeneralPath());
            }
        });
        
        ////BUTTONGROUP///////////
        shapeButtonGroup = new ButtonGroup();
        
        
        shapeButtonGroup.add(circleRadioButton);
        buttonGroupPanel.add(circleRadioButton);
        shapeButtonGroup.add(roundRectRadioButton);
        buttonGroupPanel.add(roundRectRadioButton);
        shapeButtonGroup.add(arcRadioButton);
        buttonGroupPanel.add(arcRadioButton);
        shapeButtonGroup.add(rectRadioButton);
        buttonGroupPanel.add(rectRadioButton);
        shapeButtonGroup.add(this.gPathRadioButton);
        buttonGroupPanel.add(this.gPathRadioButton);
        
        upperPanel.add(buttonGroupPanel);
        
        //Winding rules for path
        this.fillEvenOddRadioButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                ((GeneralPath)DrawUtils.getInstance().getGeneralPath()).setWindingRule(GeneralPath.WIND_EVEN_ODD);
            }
        });
        
        this.fillNonZeroRadioButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                ((GeneralPath)DrawUtils.getInstance().getGeneralPath()).setWindingRule(GeneralPath.WIND_NON_ZERO);
            }
        });
        
        
        windingRuleButtonGroup = new  ButtonGroup();
        
        this.windingRuleButtonGroup.add(fillEvenOddRadioButton);
        this.windingRuleButtonGroup.add(fillNonZeroRadioButton);
        
        this.windingRulePanel.add(fillEvenOddRadioButton);
        this.windingRulePanel.add(fillNonZeroRadioButton);
        
        upperPanel.add(windingRulePanel);
        
        
        ////////////////////////////////
        
        /////Buttons+Textfield
        
        
        buttonPanel.add(clearButton);
        buttonPanel.add(rotButton);
        
        clipping.addItemListener(
                new ItemListener() {
            public void itemStateChanged( ItemEvent e ) {
                State.setClipping(clipping.isSelected());
                canvas.repaint();
            }
        });
        buttonPanel.add(clipping);
        
        
        clearButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                cm.clear();
                canvas.repaint();
            }
        });
        
        rotButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                State.addAngle(45);
                rotAngleField.setText((double)State.getAngle()%360.0d+"");
            }
        });
        
        rotAngleField.setEditable(false);
        
        
        lowerPanel.add(buttonPanel);
        lowerPanel.add(rotAngleField);
        ////////////////////////
        
        //////FARBEN////
        
        
        
        redRadioButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                State.setFillOption(DrawUtils.getInstance().getRedPaint());
            }
        });
        
        blueRadioButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                
                State.setFillOption(DrawUtils.getInstance().getBluePaint());
                
            }
        });
        
        gradientRadioButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                
                State.setFillOption(DrawUtils.getInstance().getGradientPaint());
                
            }
        });
        
        textRadioButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                
                State.setFillOption(DrawUtils.getInstance().getTextPaint());
                
            }
        });
        
        
        colorChooserButtonGroup = new ButtonGroup();
        
        colorChooserButtonGroup.add(redRadioButton);
        colorChooserButtonGroup.add(blueRadioButton);
        colorChooserButtonGroup.add(gradientRadioButton);
        colorChooserButtonGroup.add(textRadioButton);
        
        
        colorPanel.add(redRadioButton);
        colorPanel.add(blueRadioButton);
        colorPanel.add(gradientRadioButton);
        colorPanel.add(textRadioButton);
        
        lowerPanel.add(colorPanel);
        /////////////////
        
        ///////////Nachbearbeitungen
        ditheringCheckbox.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                if (ditheringCheckbox.isSelected()) {
                    State.setDithering(true);
                } else {
                    State.setAntialiasing(false);
                }
            }
        });
        
        this.antiAliasingCheckBox.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                if (antiAliasingCheckBox.isSelected()) {
                    State.setAntialiasing(true);
                } else {
                    State.setAntialiasing(false);
                }
            }
        });
        renderingPanel.add(ditheringCheckbox);
        renderingPanel.add(antiAliasingCheckBox);
        lowerPanel.add(renderingPanel);        


        
        ////////////////////////////
        

        
        
        allPanel.setLayout(new BorderLayout());
        allPanel.add(upperPanel, BorderLayout.NORTH);
        allPanel.add(lowerPanel, BorderLayout.SOUTH);
        
        this.getContentPane().add(allPanel, BorderLayout.NORTH);
        this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        
        canvas = new RenderCanvas(cm);
        this.getContentPane().add(canvas, BorderLayout.SOUTH);
        this.setJMenuBar(menu());
        canvas.repaint();
        
    }
    /**
     * Menbar
     */
    public JMenuBar menu() {
        JMenuBar menubar = new JMenuBar();
        compMenu();
        menubar.add(compRulesMenu);
        return menubar;
    }
    
    private void compMenu() {
        
        
        compRulesMenu = new JMenu("Compositing");
        
        JMenuItem srcOverItem = new JMenuItem("SRC-Over");
        srcOverItem .addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                State.setCompositingSelection(AlphaComposite.SRC_OVER);
            }
        });
        
        compRulesMenu.add(srcOverItem);
        
        JMenuItem srcInItem = new JMenuItem("SRC-IN");
        srcInItem .addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                State.setCompositingSelection(AlphaComposite.SRC_IN);
            }
        });
        
        compRulesMenu.add(srcInItem);
        
        JMenuItem srcOutItem = new JMenuItem("SRC-OUT");
        srcOutItem .addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                State.setCompositingSelection(AlphaComposite.SRC_OUT);
            }
        });
        
        compRulesMenu.add(srcOutItem);
        
        
        JMenuItem dstOverItem = new JMenuItem("DST-OVER");
        dstOverItem .addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                State.setCompositingSelection(AlphaComposite.DST_OVER);
            }
        });
        
        compRulesMenu.add(dstOverItem);
        
     
    }
    
    public static void main(String[] args) {
        PainterView window = new PainterView("Painter");
        window.pack();
        window.setSize(800,540);
        window.setResizable(false);
        window.setVisible(true);
    }
}
